# -*- coding: utf-8 -*-


class OverlapNode(object):
    def __init__(self, read='', outarcs=[]):
        self.read=read
        self.outarcs=outarcs
    def __str__(self):
        s='node in Overlap Graph: "'+str(self.read)+'"'
        if self.outarcs:
            for label, arc in self.outarcs:
                if arc:
                    s+=" -> ("+str(label)+")"+arc.read
        return s
        
def check_overlaps(s, tlist):
    """
    Input: string s, list of strings tlist
    
    This function compares a string s with each string out of tlist; 
    for each pair (s, tlist[i]), it determines the maximum value of overlap between
    a suffix of s and a prefix of tlist[i].
    
    Output: an array of integers containing the max overlap values between s and 
    each string in tlist
    """
    #inner function, just for the sake of encapsulation
    def maxoverlap(a,b):
        n=min(len(a),len(b))
        while n:
            if a[-n:]==b[:n]:
                return n
            n-=1
        return 0
       
    return [maxoverlap(s,t) for t in tlist]

