# -*- coding: utf-8 -*-

#1a) Un assembly di reads (senza gap) viene memorizzato in una lista di tuple, 
# con tante tuple quanti sono i read; il primo elemento della tupla è l'indice, 
# nell'assembly, a partire dal quale viene posizionato il read; il secondo 
# elemento è la stringa che rappresenta il contenuto del read.
# Scrivere una funzione "to_nparr(a)" che, dato in input un assembly "a" nella 
# forma descritta, restituisca lo stesso assembly codificato come un array numpy
# bidimensionale di caratteri, con ogni riga dedicata a un read (che in essa 
# compare su caselle successive a partire dalla colonna con indice pari a 
# quello specificato); il numero di colonne dovrà essere la lunghezza 
# dell'assembly, e le caselle non coperte da read dovranno contenere "*".
#
# Es: #  ATTT
#     #    AGG
#     #     GCA
#     #   TAT
#      
#     a1=[(0,"ATTT"), (2, "AGG"), (3, "GCA"), (1,"TAT")]
#     to_nparr(a1) --> [['A' 'T' 'T' 'T' '*' '*']
#                      ['*' '*' 'A' 'G' 'G' '*']
#                      ['*' '*' '*' 'G' 'C' 'A']
#                      ['*' 'T' 'A' 'T' '*' '*']]


import numpy as np

def to_nparr(a):
    padding="*"
    clen=max([i+len(s) for i,s in a]) #first, the assembly length is found
    m=[]  #a list to host the whole strings per any assembly row
    for i,r in a:
        m.append(padding*i+r+padding*(clen-(i+len(r))))
    #now the np array is contructed out of a list of lists of characters
    return np.array([ list(r) for r in m ], dtype=str)
