# -*- coding: utf-8 -*-

#3a) Diciamo che una stringa s1 si sovrappone di k caratteri con la stringa s2
# se il suffisso lungo k di s1 coincide esattamente con il prefisso lungo k di 
# s2. Per "livello di sovrapposizione" intendiamo il massimo valore k per cui 
# si ha sovrapposizione, come qui definita. 
# Dato un insieme di stringhe, le loro mutue sovrapposizioni superiori a una 
# soglia data possono essere sintetizzate in un grafo in cui ogni nodo 
# corrisponde a una stringa, con archi uscenti verso nodi per cui si ha livello 
# di sovrapposizione superiore o uguale alla soglia, e in cui ad ogni arco è 
# associata come etichetta il rispettivo livello di sovrapposizione. 
# Un nodo di questo tipo è implementato dalla classe OverlapNode del file 
# overlap.py: i nodi uscenti vi sono rappresentati con una lista di tuple (l,n), 
# con livello di sovrapposizione "l" e nodo target "n". Si assume di escludere 
# dal grafo gli archi che ritornano sul nodo di partenza. 
# Scrivere una funzione build_OLGraph(reads, threshold) che, data in ingresso 
# una lista di stringhe e un valore di soglia, restituisca la lista di istanze 
# di OverlapNode opportunamente valorizzate per rappresentare il grafo descritto.
# Sfruttare, se ritenuto utile, anche la funzione presente in overlap.py.


from overlap import OverlapNode, check_overlaps

def build_OLGraph(reads, threshold=3):
    graph=[]
    if reads:
        for read in reads:
            graph.append(OverlapNode(read))
        for i, node in enumerate(graph):
            overlaps=check_overlaps(node.read, reads)
            node.outarcs= \
            [(o, graph[j]) for j, o in enumerate(overlaps) if o>=threshold and j!=i]
    return graph
            